<template>
    <div class="prk-order__container prk-order--step-thre prk-order__container--shadow">
       <popupEror 
         v-if="responsEror && clousPopup" 
         :eror="responsEror"
         v-on:clous-popup="clousPopup = false;noScroll();"
        />
       <h2 class="prk-order__title">INFORMATIONS SUR LE PROPRIÉTAIRE DU VÉHICULE OU SON REPRÉSENTANT</h2>
        <ProgressForm
          :currentItem="1"
        />
        <div class="prk-order__form-thre">
          <form @submit.stop.prevent>
            <div class="row">
              <div class="prk-order__form-item col-md-6">
                <label class="prk-order__label">Propriétaire du véhicule</label>
                <div class="row">
                  <div class="col-6">                
                    <label class="prk-order__container-checkbox">Société
                      <input type="radio" name="owner" v-model="formDataObj.owner" value="Société">
                      <span class="prk-order__radio"></span>
                    </label>
                  </div>
                  <div class="col-6">
                    <label class="prk-order__container-checkbox">Particulier
                      <input type="radio" name="owner" v-model="formDataObj.owner" value="Particulier">
                      <span class="prk-order__radio"></span>
                    </label>
                  </div>    
                </div>  
              </div>
              <div class="prk-order__form-item col-md-6 height-md-input">
                <div v-show="formDataObj.owner == 'Société'">
                  <label class="prk-order__label">Raison sociale</label>
                  <input 
                    type="text" 
                    name="companyName" 
                    v-model.trim="formDataObj.companyName"
                    class="prk-order__input"
                    :class="{'prk-order__is-invalid': reqCompanyNam && attemptSubmit}"
                    >
                  <div class="prk-order__invalid" v-if="reqCompanyNam && attemptSubmit">
                      Veuillez entrer le nom de l'entreprise
                  </div>
                </div>  
              </div>
              <div class="col-12">
                <div class="prk-order__divider"></div>
              </div>
              <div class="prk-order__form-item col-md-6  pt-md-4"> 
                <div class="row">
                  <div class="col-6">
                    <label class="prk-order__container-checkbox">Monsieur
                      <input type="radio" checked name="gender" value="M." v-model="formDataObj.gender">
                      <span class="prk-order__radio"></span>
                    </label>
                  </div>
                  <div class="col-6">
                    <label class="prk-order__container-checkbox">Madame
                      <input type="radio" name="gender" value="Mme." v-model="formDataObj.gender" >
                      <span class="prk-order__radio"></span>
                    </label>
                  </div>
                </div>
              </div>
              <div class="prk-order__form-item col-md-6 prk-order__form-item--flex">
                <div class="row">
                  <div class="col-6 pr-2 pr-md-3">
                    <label class="prk-order__label">Prénom</label>
                    <input 
                      type="text" 
                      v-model.trim="formDataObj.FirstName"  
                      name="FirstName" 
                      class="prk-order__input"
                      :class="{'prk-order__is-invalid': missingFirstName && attemptSubmit}">
                    <div class="prk-order__invalid" v-if="missingFirstName && attemptSubmit">
                      S'il vous plaît entrez votre nom
                    </div>
                  </div>
                  <div class="col-6 pl-2 pl-md-3">
                    <label class="prk-order__label">Nom</label>
                    <input 
                      type="text"  
                      name="LastName" 
                      v-model.trim="formDataObj.LastName" 
                      class="prk-order__input"
                      :class="{'prk-order__is-invalid': missingLastName && attemptSubmit}">
                    <div class="prk-order__invalid" v-if="missingLastName && attemptSubmit">
                      Entrez š'il vous plaît Nom
                    </div>
                  </div>
                </div> 
              </div>
              <div class="col-6 pr-2 pr-md-3">
                <label class="prk-order__label">Pays</label>
                <input 
                  type="text"  
                  name="country" 
                  v-model.trim="formDataObj.country" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': missingCountry && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingCountry && attemptSubmit">
                      S'il vous plaît entrer un pays
                </div>
              </div>
              <div class="col-6 pl-2 pl-md-3">
                <label class="prk-order__label">Ville</label>
                <input 
                  type="text"  
                  name="city" 
                  v-model.trim="formDataObj.city" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': missingCity && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingCity && attemptSubmit">
                      S'il vous plaît entrer un ville
                </div>
              </div>
              <div class="col-md-9 col-8">
                <label class="prk-order__label">Adresse</label>
                <input 
                  type="text"  
                  name="Address"  
                  v-model.trim="formDataObj.Address" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': missingAddress && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingAddress && attemptSubmit">
                      S'il vous plaît entrer votre adresse
                </div>
              </div>
              <div class="col-md-3 col-4 pl-0 pl-md-3">
                <label class="prk-order__label">Code postal</label>
                <input 
                  type="text"  
                  name="Postcode" 
                  v-model.trim="formDataObj.Postcode" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': missingPostcode && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingPostcode && attemptSubmit">
                      S'il vous plaît entrer un code postal
                </div>
              </div>
              <div class="col-md-6">
                <label class="prk-order__label">E-mail</label>
                <input 
                  type="email"  
                  name="Mail" 
                  v-model.trim="formDataObj.Mail" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': missingMail && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingMail && attemptSubmit">
                     S'il vous plaît entrer votre email
                </div>
                <div class="prk-order__invalid" v-if="!missingMail && attemptSubmit && validMail">
                     S'il vous plaît entrer une adresse email valide
                </div>
              </div>
              <div class="col-md-6">
                <label class="prk-order__label">Téléphone</label>
                <input 
                  type="tel"  
                  name="Phone" 
                  v-model.trim="formDataObj.Phone" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': missingPhone && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingPhone && attemptSubmit">
                     S'il vous plaît entrez votre numéro de téléphone
                </div>
                <div class="prk-order__invalid" v-if="!missingPhone && attemptSubmit && validPhone">
                     S'il vous plaît entrez un numéro de téléphone valide
                </div>
              </div>
            </div>
              <div class="prk-order__action">
                <button
                  type="submit" 
                  class="prk-order__button prk-order__button--next"
                  :disabled="loadRespons"
                  :class="{'prk-order__loader':loadRespons}"
                   @click="validateForm();$emit('FormThreeVal', formDataObj);" 
                  >
                  CONTINUER
                </button>
             </div>
          </form>
        </div>
        <div class="flex justify-content-center">
          <button  class="prk-order__button prk-order__button--no-bg prk-order__button--prev" @click="$emit('prev-step')">REVENIR</button>
        </div>
    </div>
</template>

<script>
import ProgressForm from './ProgressForm.vue'
import axios from 'axios'
import popupEror from './popupEror.vue'

export default {
  name: 'FromStepThree',
  components: {
    ProgressForm,
    popupEror
  },
  data() {
    return {
      attemptSubmit: false,
      loadRespons: null,
      responsEror: false,
      clousPopup: false,
      formDataObj: {
        step: 3,
        owner: 'Particulier',
        companyName: '',
        gender: 'M.',
        FirstName: '',
        LastName: '',
        Address: '',
        Postcode:'',
        Mail:'',
        Phone:'',
        city:'',
        country: '',
      },
      regMail: /^(([^<>()\\.,;:\s@"]+(\.[^<>()\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/,
      regPhone: /^[+]*[(]{0,1}[0-9]{1,4}[)]{0,1}[-\s/0-9]*$/,
    }
  },
  methods: {
    validateForm() {
      this.attemptSubmit = true;
      if (this.missingFirstName || this.missingLastName || this.reqCompanyNam || this.missingAddress || this.missingPostcode || this.missingMail || this.missingPhone || this.validMail || this.validPhone || this.missingVille || this.missingCountry || this.missingCity){
         return false;
      }else{
        this.loadRespons = true; 
          axios({
            method: 'post',
            url: '/wp-admin/admin-ajax.php',
            timeout: 60000, 
            params: {
               action: 'step_3',
            },
            data: {
              body: JSON.stringify(this.formDataObj),
            }
            })
           .then(response=>{
                if(response.data.error){
                   this.responsEror = response.data.error;
                   this.clousPopup = true;
                }else{
                   this.responsEror = false;
                } 
            })
            .catch(()=>{
                  this.responsEror = "Une erreur s'est produite, n'hésitez pas à contacter l'équipe Sales à contact@parkopoly.fr";
                  this.clousPopup = true;
            })
            .finally(()=>{
               this.loadRespons = false;
            }); 
        return true; 
      }
    },
    noScroll(){
       document.body.classList.remove('scroll-none');
    },
  },
  computed: {
    missingFirstName() { 
      return this.formDataObj.FirstName === ''; 
    },
    missingLastName() { 
      return this.formDataObj.LastName === ''; 
    },
    reqCompanyNam(){
      return this.formDataObj.owner === "Société" && this.formDataObj.companyName === '';
    },
    missingAddress(){
      return this.formDataObj.Address === ''; 
    },
    missingPostcode(){
       return this.formDataObj.Postcode === ''; 
    },
    missingMail(){
       return this.formDataObj.Mail === ''; 
    },
    missingPhone(){
       return this.formDataObj.Phone === ''; 
    },
    missingCountry(){
       return this.formDataObj.country === '';
    },
    missingCity(){
      return this.formDataObj.city === '';
    },
    validMail(){
      return  !this.regMail.test(this.formDataObj.Mail);
    },
    validPhone(){
      return  !this.regPhone.test(this.formDataObj.Phone);
    },
  },
  watch: {
     loadRespons(){
        return(!this.loadRespons &&  !this.responsEror? this.$emit('next-step'):null);
     }
  },
}
</script>

<style lang="stylus">
.prk-order
  &__devider
    -webkit-box-flex 1
    -webkit-flex auto
    -ms-flex auto
    flex: auto
    width: 100%
    height 2px
    background #ddd
@media (min-width:768px)
  .height-md-input
    min-height 107px
</style>